#pragma once

#include "System/OS.h"

#define LWE_MAX_PATH 0x104
#define LWE_UINT_8_MAX 0xFF
#define LWE_SINT_8_MAX 0x7F
#define LWE_SINT_8_MIN 0x80
#define LWE_UINT_16_MAX 0xFFFF
#define LWE_SINT_16_MAX 0x7FFF
#define LWE_SINT_16_MIN 0x8000
#define LWE_UINT_24_MAX 0xFFFFFF
#define LWE_SINT_24_MAX 0x7FFFFF
#define LWE_SINT_24_MIN 0x800000
#define LWE_UINT_32_MAX 0xFFFFFFFF
#define LWE_SINT_32_MAX 0x7FFFFFFF
#define LWE_SINT_32_MIN 0x80000000
#define LWE_UINT_64_MAX 0xFFFFFFFFFFFFFFFF
#define LWE_SINT_64_MAX 0x7FFFFFFFFFFFFFFF
#define LWE_SINT_64_MIN 0x8000000000000000
#define LWE_FLOAT_MAX 3.40282e+038f
#define LWE_FLOAT_MIN 1.17549e-038f
#define LWE_DOUBLE_MAX 1.79769e+308
#define LWE_DOUBLE_MIN 2.22507e-308
#define LWE_LDOUBLE_MAX 1.79769e+308
#define LWE_LDOUBLE_MIN 2.22507e-308

#define LWE_INFINITE LWE_UINT_32_MAX

namespace lwe
{
	typedef unsigned char Byte;
	typedef char Char_8;
	typedef wchar_t Char_16;
	typedef char32_t Char_32;
	typedef unsigned char UInt_8;
	typedef signed char SInt_8;
	typedef char Int_8;
	typedef unsigned short UInt_16;
	typedef signed short SInt_16;
	typedef short Int_16;
	typedef unsigned int UInt_32;
	typedef signed int SInt_32;
	typedef int Int_32;

	#if defined(LWE_OS_WINDOWS)
		typedef unsigned long long UInt_64;
		typedef signed long long SInt_64;
		typedef long long Int_64;
	#elif defined(LWE_OS_LINUX)
		typedef unsigned long UInt_64;
		typedef signed long SInt_64;
		typedef long Int_64;
	#endif
}