#include "IO/Socket/Operation.h"
#include "IO/Socket/CommsSystem.h"
#include "IO/Socket/Comms.h"
#include "IO/Socket/Endpoint.h"

namespace lwe
{
	Operation::Operation()
		: hashId(0)
	{
	}

	Operation::Operation(const Str_8& id)
		: id(id), hashId(id.Hash_64())
	{
	}

	Operation::Operation(const Operation& cmd)
		: id(cmd.id), hashId(cmd.hashId)
	{
	}

	Operation& Operation::operator=(const Operation& cmd)
	{
		if (this == &cmd)
			return *this;

		id = cmd.id;
		hashId = cmd.hashId;

		return *this;
	}

	void Operation::Process(Comms* comms, Endpoint* endpoint, CommsSystem* sys, Serializer<>& payload)
	{
	}

	Str_8 Operation::GetId() const
	{
		return id;
	}

	UInt_64 Operation::GetHashId() const
	{
		return hashId;
	}
}